#!usr/bin/php
<?php
    /*
     _____________
     S M A R K
     
     Version 1.1.0
     
     _____________
     L I C E N S E
     
     Copyright (c) 2010, Alexander Sasse <alexander.sasse@xelaton.com>
     
     Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
     
     The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
     
     THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
     
     _________
     U S A G E
     
     $transform = new SimplifiedMarkdownToHTML([Array of Strings, Filename, Text-String] $input);
     echo $transform->returnTextAsString();
     
     ________________________
     R E L E A S E  N O T E S
     1.0 Initial Release
     
     1.0.1
     - horizontal lines work now
     - indented lists improved
     - +html+ Tag improved, content no longer needs to be in one single line
     - handling of newlines using \r or \r\n instead of \n will be recognized now as newline-character too
     1.0.2
     - new Markup for underlined text  _underlined text_
     - new Markup for italic text ~italic text~
     - new table markup +table+ +endtable+
     - new font-, background-color markup +color=font-color/background-color+ +endcolor+
     1.0.3
     - Call-time pass-by-reference issue in PHP5 fixed
     1.1.0
     - Headline <br />-Tag/newline issues resolved
     - relative picture-links now possible e.g. folder/picture.jpg
     - pictures with endings png, gif now possible too
     - new special-quote-option +quote:Name of Author+The text to quote+endquote+ --> results in <blockquote>fieldset><legend></legend></fieldset></blockquote>
     - Table of Contents Markup +tableofcontents+ collects all headlines and creates a Table of Contents with quicklinks
     */
    
    $fp = fopen("php://stdin", "r");
    while($line = fgets($fp, 1024))
    {
        $input .= $line;
    }
    fclose($fp);
    
    $transform = new SimplifiedMarkdownToHTML($input);
    echo $transform->returnTextAsString();
    
    
    class SimplifiedMarkdown
    {
        var $text = "";
        //	var $saveHTMLObjects = "";
        var $TXTnl = "\n";
        var $TXTrnl = "\r\n"; // other possibility of newline
        var $TXTr = "\r"; // other possibility of newline
        var $transformNL = '';#-> define in child
        var $useTabs = true;
        var $tabSpace = 0; #-> define in child
        var $spaceSignTransform = '';#-> define in child
        var $TXTTabSign = "\t";
        
        var $markdownSearchForBlocks = array(
                                             'blockquoteStart' => '+quote+',
                                             'blockquoteEnd' => '+endquote+',
                                             'codeStart' => '+code+',
                                             'codeEnd' => '+endcode+',
                                             'commentStart' => '+comment+',
                                             'commentEnd' => '+endcomment+',
                                             'todoStart' => '+todo+',
                                             'todoEnd' => '+endtodo+',
                                             );
        var $markdownReplacementBlocks = array();#-> define in child
        
        var $headlineSimpleMark = '#';
        var $maxHeadlineSimpleMarks = 6;
        var $headlineTransformOpenTag = '';#-> define in child
        var $headlineTransformCloseTag = '';#-> define in child
        
        var $listOpenTag = '';#-> define in child
        var $listCloseTag = '';#-> define in child
        var $listPointMark = '';
        var $listPointMarkToDoDone = '';
        var $listPointMarkToDoNotDone = '';
        
        var $foundDisplayTableofContents = false;
        var $tableofcontentsString = '';
        
        ## Alte Bildkonvertierung, mit requirement, dass das Bild im Netz mit http liegen muss
        ##	'/(?<!=")(http:\/\/(.*?)\.(jpg|png|gif))/is', # picture-Link conversion optimiert
        
        var	$regexMarkdownSearch = array(
                                         '/\[(.*?)\]\(((.*?)) "(.*?)"\)/is', # looks for [example](http://url.com/ "Title")
                                         '/(?<!=")((.*?)\.(jpg|png|gif))/is', # picture-Link conversion optimiert
                                         '/(?<!=")(http:\/\/[a-zA-Z0-9-]?+\.?)(([a-zA-Z0-9-][a-zA-Z0-9-]+\.)+[a-zA-Z0-9-\.\/\_\?\%\#\&\=\;\~\!\(\)]+)/',
                                         
                                         '/\*\*\*\*\*(.*?)\*\*\*\*\*/is', # simple text markup inverse bold underlined
                                         '/\*\*\*\*(.*?)\*\*\*\*/is', # simple text markup inverse bold
                                         '/\*\*\*(.*?)\*\*\*/is', # simple text markup underlined
                                         '/ \_(.*?)\_/is', # simple text markup
                                         '/\*\*(.*?)\*\*/is', # simple text markup bold
                                         '/\*(.*?)\*/is', # simple text markup inverse
                                         '/\~(.*?)\~/is', # simple text markup inverse
                                         '/\-{3,}/is', # horizontal line
                                         '/^([^A-Za-z0-9]{0,})--[@] (.*?)--(.*?)<br \/>/', // ToDo List Check for done-Items
                                         '/--(.*?)--/is', # strike
                                         
                                         '/^([^A-Za-z0-9]{0,})[*+-] (.*?)<br \/>/', # first part checks for alphanumeric chars, which we don't want, second part +-* and third the text
                                         '/^([a-zA-Z0-9]{1}\.) (.*?)<br \/>/is', # list conversion  A., a., 1.
                                         
                                         '/\[\^ (.*?) \((.*?)\)\]/is', # footnote, link with title
                                         '/\[\^ (.*?)\]/is', # footnote destination
                                         '/\^\^(.*?)\^\^/is', # for the <sup> - Tag
                                         '/\+color=([#a-zA-F0-9-]{0,})\/([#a-zA-F0-9-]{0,})\+(.*?)\+endcolor\+/is', # font-color, backgroundcolor-set
                                         '/^([^A-Za-z0-9]{0,})[@] (.*?)<br \/>/', // ToDo List Check
                                         '/\+quote:(.*?)\+(.*?)\+endquote\+/is', # Blockquote Quote by
                                         );
        // Replacement Var --> implement in its class-childs
        var	$regexMarkdownReplace = array();#-> define in child
        
        function __construct()#-> define in child
        {
            
        }
        
        // get an Array or File-Path with text to do transformations
        // returns Bool
        function initWithText($ressource)
        {
            if(is_array($ressource))
            {
                $this->text = $ressource;
            }
            elseif(file_exists($ressource))
            {
                $this->text = explode("\n", file_get_contents($ressource));
            }
            else
            {
                $this->text = explode("\n", $ressource);
            }
            // put a line of spaces to the end of the text, so tags can be closed properly
            array_push($this->text, "  ");
            return true;
        }
        
        //- mark Tag-Transformation
        
        // simple Array replacement, search-array, replace-array, input-array
        function blockTransform()
        {
            // the simple replaces
            $this->text = str_replace($this->markdownSearchForBlocks, $this->markdownReplacementBlocks, $this->text);
        }
        
        function searchTableofContetentsMarkup()
        {
            if(strpos(implode("", $this->text), "+tableofcontents+") === false)
                $this->foundDisplayTableofContents = false;
            else
                $this->foundDisplayTableofContents = true;
        }
        
        function addTableofContents()
        {
            $this->text = str_replace("+tableofcontents+", "<ul>\n".$this->tableofcontentsString."</ul>\n", $this->text);
        }
        
        // headline replacement
        function headlineTransform()
        {
            $tocCounter = 1;
            // times we have to go through the text to fulfill our duty
            for($i = 0; $i < $this->maxHeadlineSimpleMarks; $i++)
            {
                // building the simple mark for lookup, going backwards from ###### to # for example
                $searchHeadlineString = str_repeat($this->headlineSimpleMark, $this->maxHeadlineSimpleMarks - $i);
                $openTagInsert = str_replace("!", $this->maxHeadlineSimpleMarks - $i, $this->headlineTransformOpenTag);
                $closeTagInsert = str_replace("!", $this->maxHeadlineSimpleMarks - $i, $this->headlineTransformCloseTag);
                
                // going through the text
                foreach($this->text as& $line)
                {
                    // searching fr headline marks, is_numeric is required to determine, if mark has been found
                    // if strpos finds mark at beginning of line 0 would be returned, which could determined as false by
                    // the if-statement
                    if(strpos($line, $searchHeadlineString) < 1 && is_numeric(strpos($line, $searchHeadlineString)))
                    {
                        // limiting the Array Output to 2, so lines like : # Issue # 1  will be performed correctly
                        $substrings = explode($searchHeadlineString, $line, 2);
                        if($this->foundDisplayTableofContents)
                        {
                            # aus einem seltsamen Grund geht die Zhlung rckwrts
                            $this->tableofcontentsString = '<li><a href="#toc_'.$tocCounter.'">'.trim(str_replace("<br />","", $substrings[1]))."</a></li>\n".$this->tableofcontentsString;
                            $line =  $substrings[0]."<a name=\"toc_".$tocCounter."\">".$openTagInsert.trim(str_replace("<br />","", $substrings[1])).$closeTagInsert."\n";
                            $tocCounter++;
                        }
                        else
                        {
                            $line =  $substrings[0].$openTagInsert.trim(str_replace("<br />","", $substrings[1])).$closeTagInsert."\n";
                        }
                    }
                }
            }
        }
        
        // font-attributes replacement
        function attributeTransform()
        {
            $this->text = preg_replace($this->regexMarkdownSearch, $this->regexMarkdownReplace, $this->text);
        }
        
        function closeLists()
        {
            // var to determine, if tag is open or closed
            $lineStart = 0;
            $indentionLevel = 0;
            $tagOpenCounter = 0;
            
            for($i = $lineStart; $i < count($this->text); $i++)
            {
                
                $line = $this->text[$i];
                //echo "<b>Tagopen $tagOpenCounter</b> -- $line<br />";
                ## finding list, open tag, increment TagOpenCounter by 1
                if(is_numeric(strpos($line, $this->listPointMark)) &&
                   strpos($line, $this->listPointMark) === $indentionLevel &&
                   $tagOpenCounter == 0
                   )
                {
                    
                    $this->text[$i] = $this->listOpenTag.$line;
                    $tagOpenCounter++;
                }
                ## when finding an indented list, open another tag, increment TagOpenCounter by 1
                elseif(is_numeric(strpos($line, $this->listPointMark)) &&
                       strpos($line, $this->listPointMark) > $indentionLevel
                       )
                {
                    $this->text[$i] = $this->listOpenTag.str_replace("\t", "", $line, $countL);
                    //echo $countL;
                    $tagOpenCounter++;
                    $indentionLevel = strpos($line, $this->listPointMark);
                }
                ## when list is upper, close indented list, decrement TagOpenCounter by 1
                elseif(is_numeric(strpos($line, $this->listPointMark)) &&
                       strpos($line, $this->listPointMark) < $indentionLevel
                       )
                {
                    // needed, if indention goes deeper than one point
                    $currentIndention = strpos($line, $this->listPointMark);
                    
                    $this->text[$i - 1] = str_replace("\t", "", str_replace($this->TXTnl, $this->listCloseTag.$this->TXTnl, $this->text[$i - 1]), $countT);
                    
                    // Hier liegt der Hund begraben, dass muss noch vernnftig eingebaut werden
                    if($indentionLevel > ($currentIndention + 1))
                    {
                        $currentIndention += 1;
                        $indentionToWorkDown = $indentionLevel;
                        //echo $indentionLevel;
                        for($tz = 0; $indentionToWorkDown > $currentIndention; $indentionToWorkDown--)
                        {
                            //echo "hmm -- $currentIndention";
                            $this->text[$i - 1] .= $this->listCloseTag;
                        }
                    }
                    $tagOpenCounter--;
                    $indentionLevel = strpos($line, $this->listPointMark);
                }
                ## when last element reached, close list, set TagOpenCounter 0
                elseif(strpos($line, $this->listPointMark) === false && $tagOpenCounter > 0)
                {
                    
                    $this->text[$i - 1] = str_replace("\t", "", str_replace($this->TXTnl, $this->listCloseTag.$this->TXTnl, $this->text[$i - 1]));
                    $tagOpenCounter--;
                    if($tagOpenCounter > 0)
                    {
                        for($j = 0; $j < $tagOpenCounter; $j++ )
                            $this->text[$i - 1] .= $this->listCloseTag;
                    }
                    $tagOpenCounter = 0;
                    $indentionLevel = 0;
                }
                ##  remove trailing tabs
                elseif(strpos($line, $this->listPointMark) != false)
                {
                    
                    $this->text[$i] = str_replace("\t", "", $this->text[$i]);
                }
            }
        }
        
        //- mark new Reference Building
        
        function lookForReferences()
        {
            $result;
            $marker_glue = "#".time()."#";
            $text_to_transform = implode($marker_glue, $this->text);
            preg_match_all('/\+ref\+(.*?)\+endref\+/', $text_to_transform, $result);
            ## special threatment to make sure every entry is handled only once
            $single_references = explode("+ref+", $text_to_transform);
            $number_of_references = 0;
            $found_references;
            for($i = 0; $i < count($single_references); $i++)
            {
                $single_references[$i] = str_replace($result[1][$number_of_references].'+endref+', '<sup id="cite_ref-'.$number_of_references.'"><a href="#cite_note-'.$number_of_references.'">['.($number_of_references + 1).']</a></sup>', $single_references[$i], $found_references);
                if($found_references > 0)
                {
                    $number_of_references++;
                    $found_references = 0;
                }
            }
            $text_to_transform = implode("", $single_references);
            
            $reference_list = '<ol class="references">';
            
            for($i = 0; $i < count($result[1]); $i++)
            {
                $reference_list .= '<li id="cite_note-'.$i.'"> <a href="#cite_ref-'.$i.'">&#x2191;</a> <small>'.$result[1][$i].'</small></li>';
            }
            
            $reference_list .= "</ol>";
            $text_to_transform = str_replace("+showreferences+", $reference_list, $text_to_transform);
            $this->text = explode($marker_glue, $text_to_transform);
        }
        
        //- mark invisible Character-Transformation
        
        // common format methods, linebreaks and tabs
        function autoLineBreaks()
        {
            // going through all line
            for($i = 0; $i < count($this->text); $i++)
            {
                // check for LineEnding in this line
                if(strpos($this->text[$i], $this->TXTnl) || strpos($this->text[$i], $this->TXTr) || strpos($this->text[$i], $this->TXTrnl))
                {
                    //$this->text[$i] = str_replace($this->TXTnl, $this->transformNL.$this->TXTnl, $this->text[$i]);
                    $this->text[$i] = strtr($this->text[$i], array($this->TXTrnl => $this->transformNL.$this->TXTnl, $this->TXTr => $this->transformNL.$this->TXTnl, $this->TXTnl => $this->transformNL.$this->TXTnl));
                }
                else
                {
                    $this->text[$i] .= $this->transformNL.$this->TXTnl;
                }
            }
        }
        
        // inserts equivalent Linebreaks
        function autoTabs()
        {
            if($this->checkForAutoTabs())
            {
                // build HTML-equivalent to TXT tab
                $useTabLenght = str_repeat($this->spaceSignTransform, $this->tabSpace);
                // going through all lines
                // $line is a pointer to the entry in $this->text, done through as&
                foreach($this->text as& $line)
                {
                    // looking up for tabs, simple replace won't work
                    $substrings = explode("\t", $line);
                    // if there are more than 1 Block Tabs are inluded
                    if(count($substrings) > 1)
                    {
                        $writeBackString = '';
                        // going through all blocks
                        foreach($substrings as $singleSubstring)
                        {
                            if(strlen($singleSubstring) < 1)
                            {
                                $writeBackString .= $useTabLenght;
                            }
                            else
                            {
                                $writeBackString .= $singleSubstring;
                            }
                        }
                        $line = $writeBackString;
                    }
                }
            }
        }
        
        function checkForAutoTabs()
        {
            return $this->useTabs;
        }
        
        //- mark returning methods
        function returnTextAsString()
        {
            return implode("", $this->text);
        }
    }
    
    class SimplifiedMarkdownToHTML extends SimplifiedMarkdown
    {
        var $textEncoding = "UTF-8"; ## important for encoding entities
        var $tabSpace = 4;
        var $spaceSignTransform = "&nbsp;";
        var $transformNL = "<br />";
        
        var $headlineTransformOpenTag = '<h!>';
        var $headlineTransformCloseTag = '</h!>';
        
        var $listOpenTag = "<ul>";
        var $listCloseTag = "</ul>";
        var $listPointMark = "<li>";
		var $listPointMarkToDoDone = "<li class=\"todoDone\">";
		var $listPointMarkToDoNotDone = "<li class=\"todoNotDone\">";
        
        var $markdownReplacementBlocks = array(
                                               'blockquoteStart' => '<blockquote>',
                                               'blockquoteEnd' => '</blockquote>',
                                               'codeStart' => '<pre><code>',
                                               'codeEnd' => '</code></pre>',
                                               'commentStart' => '<!--',
                                               'commentEnd' => '-->',
                                               'todoStart' => '<div class="todo">',
                                               'todoEnd' => '</div>',
                                               );
        
        var	$regexMarkdownReplace = array(
                                          '<a href="$2" title="$4">$1</a>',
                                          '<img src="$1" />',
                                          '<a href="$1$2">$1$2</a>',
                                          
                                          '<span style="text-decoration:underline;" class="underline"><em><strong>$1</strong></em></span>',
                                          '<em><strong>$1</strong></em>',
                                          '<span style="text-decoration:underline;" class="underline">$1</span>',
                                          '<span style="text-decoration:underline;" class="underline">$1</span>',
                                          '<strong>$1</strong>',
                                          '<em>$1</em>',
                                          '<em>$1</em>',
                                          '<hr />',
                                          '$1<a href="#"><li class="todoDone"><span style="text-decoration:line-through;" class="strike">$2</span></li></a>',
                                          '<span style="text-decoration:line-through;" class="strike">$1</span>',
                                          
                                          '$1<li>$2</li>',
                                          '<li>$1 $2</li>',
                                          
                                          '<sup><a href="#$1">$2</a></sup>',
                                          '<a name="$1">&nbsp;</a>',
                                          '<sup>$1</sup>',
                                          '<span style="color:$1; background-color:$2;">$3</span>',
                                          '$1<a href="#"><li class="todoNotDone">$2</li></a>',
                                          '<blockquote><fieldset><legend>$1</legend>$2</fieldset></blockquote>',
                                          );
        
        function __construct($ressource)
        {
            // read in text
            $this->initWithText($ressource);
            // doing all formatting
            $this->saveEmbedHTML();
            $this->findTables();
            $this->makeHTMLEntities();
			
            $this->autoLineBreaks();
            
            $this->searchTableofContetentsMarkup();
            $this->headlineTransform();
            
            
            
            $this->attributeTransform();
            $this->toDoListFormatting();
            $this->closeToDoLists();
            $this->closeLists();
            
            $this->addTableofContents();
            
            $this->lookForReferences();
            $this->autoTabs();
            $this->blockTransform();
            $this->embedTables();
            $this->embedHTML();
        }
        
        //- mark private vars and methods of simplifiedMarkdownToHTML
        // var for storing HTML-Parts to embed
        private $saveHTMLObjects = "";
        
        // encode Entities for best compatibility and showing HTML-Code
        private function makeHTMLEntities()
        {
            foreach($this->text as& $line)
            {
                // encode entities, leaving ' and " alone
                $line = htmlentities($line, ENT_NOQUOTES, $this->textEncoding);
            }
        }
        
        // find HTML-Blocks and store them
        private function saveEmbedHTML()
        {
            preg_match_all('/\+html\+(.*?)\+endhtml\+/', implode("", $this->text), $this->saveHTMLObjects);
        }
        
        // reimplement HTML-Blocks, erasing the HTML-Block-Tags
        private function embedHTML()
        {
            if(is_array($this->saveHTMLObjects))
            {
                $fullText = implode('', $this->text);
                $search = $this->saveHTMLObjects[0];
                $replace = $this->saveHTMLObjects[1];
                
                for($i = 0; $i < count($search); $i++)
                {
                    $fullText = preg_replace('/\+html\+(.*?)\+endhtml\+/is', $replace[$i], $fullText, 1);
                }
                $this->text = explode('\n', $fullText);
            }
        }
        
        private $saveTheTables = "";
        private function findTables()
        {
            /**/
            $saveTableObjects = "";
            $fullText = implode("++seperator++", $this->text);
            preg_match_all('/\+table\+(.*?)\+endtable\+/',  $fullText, $saveTableObjects);
            //echo "<pre>"; var_dump($saveTableObjects); echo "</pre>";
            if(is_array($saveTableObjects))
            {
                for($i = 0; $i < count($saveTableObjects[1]); $i++)
                {
                    $saveTableObjects[1][$i] = htmlentities($saveTableObjects[1][$i], ENT_NOQUOTES, $this->textEncoding);
                    $saveTableObjects[1][$i] = preg_replace($this->regexMarkdownSearch, $this->regexMarkdownReplace, $saveTableObjects[1][$i]);
                    //
                    $pieces = explode("++seperator++", $saveTableObjects[1][$i]);
                    $colStart = false;
                    $theTable = "<table>\n";
                    for($j = 0; $j < count($pieces); $j++)
                    {
                        if(trim($pieces[$j]) != "")
                        {
                            # check nach zustzlichen Attributen
                            if(strstr($pieces[$j], "align="))
                            {
                                $alignMent = explode("=", $pieces[$j]);
                                $alignMent[1] = trim($alignMent[1]);
                                if($alignMent[1] == "center" || $alignMent[1] == "left" || $alignMent[1] == "right")
                                    $setAlignment = " align=\"".$alignMent[1]."\"";
                            }
                            elseif(strstr($pieces[$j], "+tablehead+"))
                            {
                                $theTable .= "\t<thead>\n";
                                $colStart = true;
                            }
                            elseif(strstr($pieces[$j], "+endtablehead+"))
                            {
                                $theTable .= "\t</thead>\n";
                                $colStart = false;
                            }
                            ## normale Zeilen
                            elseif($colStart == false)
                            {
                                $theTable .= "\t<tr>\n";
                                $colStart = true;
                                $theTable .= "\t\t<td".$setAlignment.">".$pieces[$j]."</td>\n";
                            }
                            else
                            {
                                $theTable .= "\t\t<td".$setAlignment.">".$pieces[$j]."</td>\n";
                            }
                            
                        }
                        else
                        {
                            if($colStart == true)
                            {
                                $theTable .= "\t</tr>\n";
                                $colStart = false;
                            }
                        }
                    }
                    $theTable .= "</table>\n";
                    $this->saveTheTables[] = $theTable;
                }
            }
        }
        
        private function embedTables()
        {
            if(is_array($this->saveTheTables))
            {
                //echo "Wir sind drin";
                $fullText = implode('', $this->text);
                //$search = $this->saveHTMLObjects[0];
                //$replace = $this->saveHTMLObjects[1];
                
                for($i = 0; $i < count($this->saveTheTables); $i++)
                {
                    $fullText = preg_replace('/\+table\+(.*?)\+endtable\+/is', $this->saveTheTables[$i], $fullText, 1);
                }
                $this->text = explode('\n', $fullText);
            }
        }
        
        private function toDoListFormatting()
		{
			$foundItems = 0;
			for($i = 0; $i < count($this->text); $i++)
			{
				if(strpos($this->text[$i], "<a href=\"#\"><li class=\"todoNotDone\">") !== false)
				{
					$this->text[$i] = str_replace("<a href=\"#\"><li class=\"todoNotDone\">","<a href=\"#\" onClick=\"window.SmarkToDo.markToDo_($i)\"><li class=\"todoNotDone\">", $this->text[$i]);
					
					// sollte lieber preg_replace verwenden, um sicher zu stellen, dass nur der erste verwendet wird
					// preg_replace(mixed pattern, mixed replacement, mixed subject [, int limit [, int &count]])
				}
				elseif(strpos($this->text[$i], "<a href=\"#\"><li class=\"todoDone\">") !== false)
				{
					$this->text[$i] = str_replace("<a href=\"#\"><li class=\"todoDone\">","<a href=\"#\" onClick=\"window.SmarkToDo.unmarkToDo_($i)\"><li class=\"todoDone\">", $this->text[$i]);
				}
			}
		}
        
        private function closeToDoLists()
        {
            // var to determine, if tag is open or closed
            $lineStart = 0;
            $indentionLevel = 0;
            $tagOpenCounter = 0;
            
            for($i = $lineStart; $i < count($this->text); $i++)
            {
                $line = $this->text[$i];
                
                if(is_numeric(strpos($line, $this->listPointMarkToDoDone)))
                {
                    $currentPosition = 0;
                    str_replace("\t", "", $line, $currentPosition);
                }
                else if(is_numeric(strpos($line, $this->listPointMarkToDoNotDone)))
                {
                    $currentPosition = 0;
                    str_replace("\t", "", $line, $currentPosition);
                }
                else
                    $currentPosition = false;
				
                //echo $currentPosition."\n";
                
                ## finding list, open tag, increment TagOpenCounter by 1
                if(is_numeric($currentPosition) &&
                   $currentPosition === $indentionLevel &&
                   $tagOpenCounter == 0
                   )
                {
                    $this->text[$i] = $this->listOpenTag.$line;
                    $tagOpenCounter++;
                }
                ## when finding an indented list, open another tag, increment TagOpenCounter by 1
                elseif(is_numeric($currentPosition) &&
                       $currentPosition > $indentionLevel
                       )
                {
                    $this->text[$i] = $this->listOpenTag.str_replace("\t", "", $line, $countL);
                    //echo $countL;
                    $tagOpenCounter++;
                    $indentionLevel = $currentPosition;
                }
                ## when list is upper, close indented list, decrement TagOpenCounter by 1
                elseif(is_numeric($currentPosition) &&
                       $currentPosition < $indentionLevel
                       )
                {
                    // needed, if indention goes deeper than one point
                    $currentIndention = $currentPosition;
                    
                    $this->text[$i - 1] = str_replace("\t", "", str_replace($this->TXTnl, $this->listCloseTag.$this->TXTnl, $this->text[$i - 1]), $countT);
                    
                    // Hier liegt der Hund begraben, dass muss noch vernnftig eingebaut werden
                    if($indentionLevel > ($currentIndention + 1))
                    {
                        $currentIndention += 1;
                        $indentionToWorkDown = $indentionLevel;
                        //echo $indentionLevel;
                        for($tz = 0; $indentionToWorkDown > $currentIndention; $indentionToWorkDown--)
                        {
                            //echo "hmm -- $currentIndention";
                            $this->text[$i - 1] .= $this->listCloseTag;
                        }
                    }
                    $tagOpenCounter--;
                    $indentionLevel = $currentPosition;
                    
                }
                ## when last element reached, close list, set TagOpenCounter 0
                elseif($currentPosition === false && $tagOpenCounter > 0)
                {
                    
                    $this->text[$i - 1] = str_replace("\t", "", str_replace($this->TXTnl, $this->listCloseTag.$this->TXTnl, $this->text[$i - 1]));
                    $tagOpenCounter--;
                    if($tagOpenCounter > 0)
                    {
                        for($j = 0; $j < $tagOpenCounter; $j++ )
                        {
                            $this->text[$i - 1] .= $this->listCloseTag;
                        }
                    }
                    $tagOpenCounter = 0;
                    $indentionLevel = 0;
                }
                ##  remove trailing tabs
                elseif($currentPosition != false)
                {
                    $this->text[$i] = str_replace("\t", "", $this->text[$i]);
                }
            }
        }
    }
    
    class SimplifiedMarkdownToHTMLNoEncoding extends SimplifiedMarkdownToHTML
    {
        var $textEncoding = ""; ## important for encoding entities
    }
    
    ?>