#!usr/bin/php
<?php
/*
_____________
W I K I T E X T PHP-Class

Version 1.0

_____________
L I C E N S E

Copyright (c) 2010, Alexander Sasse <alexander.sasse@xelaton.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

_________
U S A G E

$transform = new WikitextTransformer([Array of Strings, Filename, Text-String] $input);
echo $transform->performTransformation();
*/

/**/
$fp = fopen("php://stdin", "r");
while($line = fgets($fp, 1024))
{
	$input .= $line;
}
fclose($fp);

$transformer = new WikitextTransformer($input);
echo $transformer->performTransformation();

/*
	## Changelog ##
	20.11.09 -- infoboxen und tabellen sollten nun richtig gehen
*/
/*
	## ToDos ##
	- Listendarstellung ist noch nicht in Ordnung, zu große Abstände mitten drin <br />s dürfen da nicht rein
*/
class WikitextTransformer
{
	var $TXTnl;
	var $transformNL;
	var $mainLanguage;
	var $internalWikiLinks;
	
	var $search_array = array(
								'/----/',
								'/=====(.*?)=====/is',
								'/====(.*?)====/is',
								'/===(.*?)===/is',
								'/==(.*?)==/is',
								'/\'\'\'\'\'(.*?)\'\'\'\'\'/is',
								'/\'\'\'(.*?)\'\'\'/is',
								'/\'\'(.*?)\'\'/is',
								//'/(http:\/\/[a-zA-Z0-9-]?+\.?)(([a-zA-Z0-9-][a-zA-Z0-9-]+\.)+[a-zA-Z0-9-\.\/\_\?\%\#\&\=\;\~\!\(\)]+)/',
								'/\[(?<!=")(http:\/\/(.*?)) (.*?)\]/',
								'/(?<!=")(http:\/\/(.*?)) /',
								'/\[\[(.*?):(.*?)\]\]/is',
								'/\[\[(.*?)\|(.*?)\]\]/is',
								'/\[\[(.*?)\]\]/is',								
		);
	var $replace_array ;	
	var $text_to_transform;
	
	function WikitextTransformer($text_input)
	{	
		if(is_array($text_input))
		{
			$this->text_to_transform = $text_input;
		}
		elseif(file_exists($text_input))
		{
			echo "Hier";
			$this->text_to_transform = explode("\n", file_get_contents($text_input));				
		}
		else
		{			
			$this->text_to_transform = explode("\n", $text_input);
		}
		
		$this->initVariables();
	}
	
	function initVariables()
	{
		$this->XTnl = "\n";
		$this->transformNL = "<br />";
		$this->mainLanguage = "de";
		$this->internalWikiLinks = ".wikipedia.org/wiki/";
		$this->replace_array = array(
						'<hr />',
						'<h4>$1</h4>',
						'<h3>$1</h3>',
						'<h2>$1</h2>',
						'<h1>$1</h1>',
						'<strong><em>$1</em></strong>',
						'<strong>$1</strong>',
						'<em>$1</em>',
						'<a href="$1">$3</a>',
						'<a href="$1">$1</a>',
						'<a href="http://$1'.$this->internalWikiLinks.'$2">$2</a>',
						'<a href="http://'.$this->mainLanguage.$this->internalWikiLinks.'$1">$2</a>',
						'<a href="http://'.$this->internalWikiLinks.'$1">$1</a>',						
		);
	}
	
	function lookForLists()
	{
		$list_bullet_open = $list_bullet_deep_open = $list_numeric_open = $list_numeric_deep_open =false;
		for($i = 0; $i < count($this->text_to_transform); $i++)
		{
			$find_list_position = strpos($this->text_to_transform[$i], "* ");
			$find_list_position_deep = strpos($this->text_to_transform[$i], "** ");
			$find_list_position_num = strpos($this->text_to_transform[$i], "# ");
			$find_list_position_num_deep = strpos($this->text_to_transform[$i], "## ");
			
			if(is_numeric($find_list_position_deep) && $find_list_postion_deep == 0)			
			{
				if($list_bullet_deep_open) $pre =""; else {$pre = "<ul>"; $list_bullet_deep_open = true;}
				$this->text_to_transform[$i] = $pre."<li>".str_replace("** ", "", $this->text_to_transform[$i])."</li>";
			}
			elseif(is_numeric($find_list_position_num_deep) && $find_list_postion_num_deep == 0)			
			{
				if($list_numeric_deep_open) $pre = ""; else {$pre = "<ol>"; $list_numeric_deep_open = true;}
				$this->text_to_transform[$i] = $pre."<li>".str_replace("## ", "", $this->text_to_transform[$i])."</li>";
			}
			elseif(is_numeric($find_list_position) && $find_list_postion == 0)			
			{
				if($list_numeric_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ol>";
					$list_numeric_deep_open = false;
				}
				elseif($list_bullet_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ul>";
					$list_bullet_deep_open = false;
				}
				if($list_bullet_open) $pre = ""; else {$pre = "<ul>"; $list_bullet_open = true;}
				$this->text_to_transform[$i] = $pre."<li>".str_replace("* ", "", $this->text_to_transform[$i])."</li>";				
			}
			elseif(is_numeric($find_list_position_num) && $find_list_postion_num == 0)			
			{
				
				if($list_numeric_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ol>";
					$list_numeric_deep_open = false;
				}
				elseif($list_bullet_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ul>";
					$list_bullet_deep_open = false;
				}
				if($list_numeric_open) $pre = ""; else {$pre = "<ol>"; $list_numeric_open = true;}
				$this->text_to_transform[$i] = $pre."<li>".str_replace("# ", "", $this->text_to_transform[$i])."</li>";
			}
			else
			{
			
				if($list_numeric_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ol>";
					$list_numeric_deep_open = false;
				}
				elseif($list_bullet_deep_open)
				{
					$this->text_to_transform[$i-1] .= "</ul>";
					$list_bullet_deep_open = false;
				}
				elseif($list_numeric_open)
				{
					$this->text_to_transform[$i-1] .= "</ol>";
					$list_numeric_open = false;
				}
				elseif($list_bullet_open)
				{					
					$this->text_to_transform[$i-1] .= "</ul>";
					$list_bullet_open = false;
				}
			}
		}
	}

	function makeParagraphs()
	{
		$this->text_to_transform = explode("\n\n", $this->text_to_transform);
		for($i = 0; $i < count($this->text_to_transform); $i++)
		{
			$this->text_to_transform[$i] = "<p>".$this->text_to_transform[$i]."</p>";
		}
		$this->text_to_transform = implode("", $this->text_to_transform);
		return $this->text_to_transform;
	}

	function autoLineBreaks()
	{
		// helper variable to prevent <br /> in Tables
		$table_open = false;
		// going through all line
		for($i = 0; $i < count($this->text_to_transform); $i++)
		{
			// check for LineEnding in this line
			if(is_numeric(strpos($this->text_to_transform[$i], '<table')))
			{
				$table_open = true;				
			}
			elseif(is_numeric(strpos($this->text_to_transform[$i], "</table>")))
			{
				$table_open = false;
			}			
			// finding head and lines <h1> <hr> and list elements
			elseif(is_numeric(strpos($this->text_to_transform[$i], "<h")) ||
				   is_numeric(strpos($this->text_to_transform[$i], "<ol>")) ||
				   is_numeric(strpos($this->text_to_transform[$i], "</ol>")) ||
				   is_numeric(strpos($this->text_to_transform[$i], "<ul>")) ||
				   is_numeric(strpos($this->text_to_transform[$i], "</ul>")) ||
				   is_numeric(strpos($this->text_to_transform[$i], "<li>"))
				  )
			{
				// do nothing
				//- mark das sollte anders sein
			}
			elseif(is_numeric(strpos($this->text_to_transform[$i], $this->TXTnl)) && $table_open == false)
			{
				$this->text_to_transform[$i] = str_replace($this->TXTnl, $this->transformNL.$this->TXTnl, $this->text_to_transform[$i]);
			}
			elseif($table_open == false)
			{
				$this->text_to_transform[$i] .= $this->transformNL.$this->TXTnl;
			}
		}
	}
	
	function simpleReplacing()
	{
		return preg_replace($this->search_array, $this->replace_array, $this->text_to_transform);
	}
	
	function findReferences()
	{
		$result;
		preg_match_all('/<ref>(.*?)<\/ref>/', $this->text_to_transform, $result);
		## spezielle Behandlung, um sicher zu stellen, dass jeder Eintrag nur einmal ersetzt wird
		$single_references = explode("<ref>", $this->text_to_transform);
		$number_of_references = 0;
		$found_references;
		for($i = 0; $i < count($single_references); $i++)
		{
			$single_references[$i] = str_replace($result[1][$number_of_references].'</ref>', '<a href="#cite_note-'.$number_of_references.'"><sup id="cite_ref-'.$number_of_references.'">['.($number_of_references + 1).']</sup></a>', $single_references[$i], $found_references);
			if($found_references > 0)
			{
				$number_of_references++;
				$found_references = 0;
			}
		}
		$this->text_to_transform = implode("", $single_references);
		$reference_list = "<ol>";
		
		for($i = 0; $i < count($result[1]); $i++)
		{
			$reference_list .= '<li id="cite_note-'.$i.'"> <a href="#cite_ref-'.$i.'">&#x2191;</a> <small>'.$result[1][$i].'</small></li>';
		}
		
		$reference_list .= "</ol>";
		$this->text_to_transform = str_replace("<references/>", $reference_list, $this->text_to_transform);
		return $this->text_to_transform;
	}
	
	function infoboxFormatting()
	{
		$result;
		$found_infoboxes = preg_match_all('/\{\{Infobox(.*?)\}\}/is', $this->text_to_transform, $result);
		$final_infobox_result;
		if($found_infoboxes >=0)
		{
			foreach($result[0] as $single_infobox)
			{
				$single_infobox = substr_replace($single_infobox, "", strrpos($single_infobox, "}}"));
				$temp_rows = explode("|", $single_infobox);			
				$infobox_result = "<table border=\"1\"><tr><th colspan=\"2\">".str_replace("{{Infobox", "", $temp_rows[0])."</th></tr>";
				for($i = 1; $i < count($temp_rows); $i++)
				{
					$temp_columns = explode(" = ", $temp_rows[$i]);
					$infobox_result .= "\n<tr>\n\t<td valign=\"top\">\n\t\t<strong>".$temp_columns[0]."</strong>\n\t</td>\n\t<td>".$temp_columns[1]."\n\t</td>\n</tr>";
				}
				$infobox_result .= "</table>";
				
				$this->text_to_transform = preg_replace('/\{\{Infobox(.*?)\}\}/is', $infobox_result, $this->text_to_transform , 1);
			}
		}		
		return $this->text_to_transform;
	}
	
	function tableFormatting()
	{
		$result;
		$found_tables = preg_match_all('/\{\|(.*?)\|\}/is', $this->text_to_transform, $result);
		$final_table_result;
		if($found_tables >= 1)
		{
			$theMatches = $result[0];
			foreach($theMatches as $table)
			{			
				$table_lines = explode("#ExplodePoint#",$table);
				$final_table = "";
			
				foreach($table_lines as $single_line)
				{
					if(is_numeric(strpos($single_line, "{|")))
					{
						##prüfen, ob eine CSS-Klasse angegeben wurde
						if(is_numeric(strpos($single_line, "class=")))
						{
							$final_table[] = str_replace("{|", "<table", $single_line)." border='1'>\n";
						}
						else
						{
							$final_table[] = str_replace("{|", "<table>", $single_line);
						}
					}
					elseif(is_numeric(strpos($single_line, "|}")))
					{
						$final_table[] = str_replace("|}", "</table>", $single_line);
					}
					elseif(is_numeric(strpos($single_line, "|-")))
					{
						if(is_numeric(strpos($single_line, "class=")))
						{
							$final_table[] = str_replace("|-", "\t<tr", $single_line)." >\n";
						}
						else
						{
							$final_table[] = str_replace("|-", "\t<tr>\n", $single_line);
						}
					}
					elseif(is_numeric(strpos($single_line, "|")))
					{	
						$single_line = str_replace("<br />|", "", $single_line);
						$pieces = explode("||", $single_line);
						
						$resulting_line = "";
						
						for($i = 0; $i < count($pieces); $i++)
						{
							$resulting_line .= "\t\t<td>" . str_replace("|", "", trim($pieces[$i])) . "</td>\n";
						}
						$final_table[] = $resulting_line . "\t</tr>\n";
					}
//- mark sollte auch nach Position abgefragt werden			
					elseif(is_numeric(strpos($single_line, "!")))
					{
						$resulting_line = "";
						$pieces = explode("!!", $single_line);
						for($i = 0; $i < count($pieces); $i++)
						{
							$resulting_line .= "\t\t<td>" . trim($pieces[$i]) . "</td>\n";
						}
						$final_table[] = $resulting_line . "\t</tr>\n";
					}		
				}
				
				$final_table_result[] = implode("#ExplodePoint#", $final_table);
			}

			foreach($final_table_result as $single_final_table)
			{		
				$this->text_to_transform = preg_replace('/\{\|(.*?)\|\}/is', $single_final_table, $this->text_to_transform , 1);
			}
		}
		return $this->text_to_transform;
	}
	
	function performTransformation()
	{
		$this->lookForLists();
		$this->text_to_transform = $this->simpleReplacing();
		$this->text_to_transform = implode("#ExplodePoint#", $this->text_to_transform);
		$this->text_to_transform = $this->findReferences();
		$this->text_to_transform = $this->infoboxFormatting();
		$this->text_to_transform = $this->tableFormatting();
		$this->text_to_transform = $this->makeParagraphs();
		$this->text_to_transform = explode("#ExplodePoint#", $this->text_to_transform);
		$this->autoLineBreaks();
		return implode("\n", $this->text_to_transform);
	}
}
?>